-------------------------------------------------------------------------------
-- QuestLevels v0.7
-------------------------------------------------------------------------------
--
-- Copyright (c) 2014, 2015 Ales Machat (Garkin)
--
-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:
--
-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.
--
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.
--
-------------------------------------------------------------------------------

--World Map hook
local SetupQuestHeader = WORLD_MAP_QUESTS.SetupQuestHeader
WORLD_MAP_QUESTS.SetupQuestHeader = function(...)
   local _, control, data = ...
   SetupQuestHeader(...)

   if data then
      local nameControl = GetControl(control, "Name")
      nameControl:SetText(zo_strformat("[<<1>>] <<2>>", data.level, data.name))
   end
end

--Quest Journal hook
local TreeEntrySetup = QUEST_JOURNAL_KEYBOARD.navigationTree.templateInfo.ZO_QuestJournalNavigationEntry.setupFunction
QUEST_JOURNAL_KEYBOARD.navigationTree.templateInfo.ZO_QuestJournalNavigationEntry.setupFunction = function(self, control, data, ...)
   TreeEntrySetup(self, control, data, ...)
   control:SetText(zo_strformat("[<<1>>] <<2>>", data.level, data.name))
end

--Quest Tracker hook
local InitializeQuestHeader = FOCUSED_QUEST_TRACKER.InitializeQuestHeader
FOCUSED_QUEST_TRACKER.InitializeQuestHeader = function(self, questName, questType, questHeader, ...)
   local newQuestName = zo_strformat("[<<1>>] <<2>>", questHeader.m_Data.level, questName)
   InitializeQuestHeader(self, newQuestName, questType, questHeader, ...)
end

EVENT_MANAGER:RegisterForEvent("QuestLevels", EVENT_ADD_ON_LOADED, function(code, name)
      if name == "QuestLevels" then
         QUEST_JOURNAL_KEYBOARD:RefreshQuestList()
         EVENT_MANAGER:UnregisterForEvent(name, code)
      end
   end)